#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, o, a, b, ab, broj;
    string grupa;

    cin >> n >> o >> a >> b >> ab;

    vector<tuple<char, int, int, int, int, int>> pacijenti;

    for(int i=0; i < n; i++)
    {
        cin >> grupa >> broj;

        if(grupa == "AB")
        {
            pacijenti.push_back(make_tuple('C', broj, 0, 0, 0, 0));
        }
        else
        {
            pacijenti.push_back(make_tuple(grupa[0], broj, 0, 0, 0, 0));
        }
    }

    for(int i=0; i < n; i++)
    {
        if(get<0>(pacijenti[i]) == 'O')
        {
            if(o >= get<1>(pacijenti[i]))
            {
                get<2>(pacijenti[i]) = get<1>(pacijenti[i]);
                o -= get<1>(pacijenti[i]);
            }
            else
            {
                cout << "nemoguce" << endl;
                return 0;
            }
        }
    }

    for(int i=0; i < n; i++)
    {
        if(get<0>(pacijenti[i]) == 'A')
        {
            if(a >= get<1>(pacijenti[i]))
            {
                get<3>(pacijenti[i]) = get<1>(pacijenti[i]);
                a -= get<1>(pacijenti[i]);
            }
            else
            {
                if(a + o >= get<1>(pacijenti[i]))
                {
                    get<3>(pacijenti[i]) = a;
                    get<2>(pacijenti[i]) = get<1>(pacijenti[i]) - a;
                    o -= get<1>(pacijenti[i]) - a;
                    a = 0;
                }
                else
                {
                    cout << "nemoguce" << endl;
                    return 0;
                }
            }
        }
    }

    for(int i=0; i < n; i++)
    {
        if(get<0>(pacijenti[i]) == 'B')
        {
            if(b >= get<1>(pacijenti[i]))
            {
                get<4>(pacijenti[i]) = get<1>(pacijenti[i]);
                b -= get<1>(pacijenti[i]);
            }
            else
            {
                if(b + o >= get<1>(pacijenti[i]))
                {
                    get<4>(pacijenti[i]) = b;
                    get<2>(pacijenti[i]) = get<1>(pacijenti[i]) - b;
                    o -= get<1>(pacijenti[i]) - b;
                    b = 0;
                }
                else
                {
                    cout << "nemoguce" << endl;
                    return 0;
                }
            }
        }
    }

    for(int i=0; i < n; i++)
    {
        if(get<0>(pacijenti[i]) == 'C')
        {
            if(ab >= get<1>(pacijenti[i]))
            {
                get<5>(pacijenti[i]) = get<1>(pacijenti[i]);
                ab -= get<1>(pacijenti[i]);
            }
            else if(ab + o >= get<1>(pacijenti[i]))
            {
                get<5>(pacijenti[i]) = ab;
                get<2>(pacijenti[i]) = get<1>(pacijenti[i]) - ab;
                o -= get<1>(pacijenti[i]) - ab;
                ab = 0;
            }
            else if(ab + o + a >= get<1>(pacijenti[i]))
            {
                get<5>(pacijenti[i]) = ab;
                get<2>(pacijenti[i]) = o;
                get<3>(pacijenti[i]) = get<1>(pacijenti[i]) - ab - o;
                a -= get<1>(pacijenti[i]) - ab - o;
                ab = 0;
                o = 0;
            }
            else if(o + a + b + ab >= get<1>(pacijenti[i]))
            {
                get<5>(pacijenti[i]) = ab;
                get<2>(pacijenti[i]) = o;
                get<3>(pacijenti[i]) = a;
                get<4>(pacijenti[i]) = get<1>(pacijenti[i]) - ab - o - a;
                b -= get<1>(pacijenti[i]) - ab - o - a;
                ab = 0;
                o = 0;
                a = 0;
            }
            else
            {
                cout << "nemoguce" << endl;
                return 0;
            }
        }
    }

    cout << "moguce" << endl;

    for(int i=0; i < n; i++)
    {
        cout << get<2>(pacijenti[i]) << " " << get<3>(pacijenti[i]) << " " << get<4>(pacijenti[i]) << " " << get<5>(pacijenti[i]) << endl;
    }
    return 0;
}